#ifndef __misc_h_
#define __misc_h_

#include <stdlib.h>
#include <inttypes.h>
#include <math.h>

#ifdef HAVE_BYTESWAP_H
#include <byteswap.h>
#else

#define bswap_16(x) \
( \
	((uint16_t)( \
		(((uint16_t)(((uint16_t) x)) & (uint16_t)0x00ffU) << 8) | \
		(((uint16_t)(((uint16_t) x)) & (uint16_t)0xff00U) >> 8) )) \
)

#define bswap_32(x) \
( \
	((uint32_t)( \
		(((uint32_t)(((uint32_t) x)) & (uint32_t)0x000000ffUL) << 24) | \
		(((uint32_t)(((uint32_t) x)) & (uint32_t)0x0000ff00UL) <<  8) | \
		(((uint32_t)(((uint32_t) x)) & (uint32_t)0x00ff0000UL) >>  8) | \
		(((uint32_t)(((uint32_t) x)) & (uint32_t)0xff000000UL) >> 24) )) \
)

#define bswap_64(x) \
( \
	((uint64_t)( \
		(uint64_t)(((uint64_t)(((uint64_t) x)) & (uint64_t)0x00000000000000ffULL) << 56) | \
		(uint64_t)(((uint64_t)(((uint64_t) x)) & (uint64_t)0x000000000000ff00ULL) << 40) | \
		(uint64_t)(((uint64_t)(((uint64_t) x)) & (uint64_t)0x0000000000ff0000ULL) << 24) | \
		(uint64_t)(((uint64_t)(((uint64_t) x)) & (uint64_t)0x00000000ff000000ULL) <<  8) | \
	        (uint64_t)(((uint64_t)(((uint64_t) x)) & (uint64_t)0x000000ff00000000ULL) >>  8) | \
		(uint64_t)(((uint64_t)(((uint64_t) x)) & (uint64_t)0x0000ff0000000000ULL) >> 24) | \
		(uint64_t)(((uint64_t)(((uint64_t) x)) & (uint64_t)0x00ff000000000000ULL) >> 40) | \
		(uint64_t)(((uint64_t)(((uint64_t) x)) & (uint64_t)0xff00000000000000ULL) >> 56) )) \
)

#endif /* !HAVE_BYTESWAP_H */

void be2le (char *data, size_t len);
int fp_round_mode_from_bits (unsigned int bits);
unsigned int fp_round_mode_to_bits (int rm);

/** Ensures that all NaNs are represented equally (bitwise) */
static inline double
normalize_nan (double d)
{
#ifdef NORMALIZE_NAN	
	if (isnan (d))
	{
		uint64_t ithenan = 0x7fffffffffffffffll;
		static double *thenan = (double *) &ithenan;
		//assert (isnan (*thenan));
		return *thenan;
	}
	else
	{
		return d;
	}
#else
	return d;
#endif	
}

#endif
