#ifndef __trace_h_
#define __trace_h_

#include <stdlib.h>
#include <stdio.h>

class state;
class instance;

#ifdef TRACE
void trace_set_file (FILE *f);
void trace_set_start_cycle (int cycle);
int tracef (const char *system, int system_id, const char *format, ...);
int tracef_plain (const char *format, ...);
int tracef_inst (state *proc, instance *inst);
void tracef_registers (state *proc, const char *tip);
#else
#define trace_set_file(f)
#define trace_set_start_cycle(c)
#define tracef(x, ...)
#define tracef_plain(...)
#define tracef_inst(x, y)
#define tracef_registers(x, y) 
#endif

#ifdef __GNUC__
#define NOT_CHECKED tracef ("other", 0, "NOT CHECKED: %s:%d:%s\n", __FILE__, __LINE__, __PRETTY_FUNCTION__)
#else
#define NOT_CHECKED tracef ("other", 0, "NOT CHECKED: %s:%d\n", __FILE__, __LINE__)
#endif

#endif
