#include "misc.h"
#include <assert.h>

void 
be2le (char *data, size_t len)
{
	assert (len % 4 == 0);
	unsigned int *d = (unsigned int *) data;
	len /= 4;
	for (size_t i = 0; i < len; ++i)
	{
		d[i] = bswap_32 (d[i]);
	}
}

#ifdef RSIM_X86LINUX
#include <fenv.h>

int
fp_round_mode_from_bits (unsigned int bits)
{
	switch (bits)
	{
	case 0x0:
		return FE_TONEAREST;
	case 0x1:
		return FE_DOWNWARD;
	case 0x2:
		return FE_UPWARD;
	case 0x3:
		return FE_TOWARDZERO;
	default:
		assert (false);
	}
}

unsigned int 
fp_round_mode_to_bits (int rm)
{
	switch (rm)
	{
	case FE_TONEAREST:
		return 0x0;
	case FE_DOWNWARD:
		return 0x1;
	case FE_UPWARD:
		return 0x2;
	case FE_TOWARDZERO:
		return 0x3;
	default:
		assert (false);
	}
}

#else
int
fp_round_mode_from_bits (unsigned int bits)
{
	return bits;
}

unsigned int 
fp_round_mode_to_bits (int rm)
{
	return rm;
}
#endif
